[tox]
envlist =
    lint
    py38
    py39
    py310
    py311
    py312
    py313
    coverage
    docs
skip_missing_interpreters =
    true

[testenv]
deps =
    zope.testrunner
commands =
    zope-testrunner --test-path src --tests-pattern ^tests {posargs}

[testenv:lint]
basepython = python3.12
deps =
    pre-commit
skip_install = true
commands =
    pre-commit run -a
passenv =
    XDG_CACHE_HOME
    HOME

[testenv:docs]
basepython =
    python3.11
commands =
    sphinx-build -b html -d src/lazr/delegates/docs/_build/doctrees src/lazr/delegates/docs src/lazr/delegates/docs/_build/html
deps =
    .[docs]

[testenv:coverage]
basepython = python3.12
deps =
    coverage
    zope.testrunner
commands =
    coverage erase
    coverage run -m zope.testrunner --test-path src --tests-pattern ^tests {posargs}
    coverage html
    coverage report -m --fail-under=100

[coverage:run]
source = lazr.delegates
omit = */docs/conf.py

[coverage:paths]
source =
    src
    .tox/*/site-packages
